package de.ozgcloud.admin;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;

import com.mongodb.client.MongoClient;

import net.javacrumbs.shedlock.core.LockProvider;
import net.javacrumbs.shedlock.provider.mongo.MongoLockProvider;
import net.javacrumbs.shedlock.spring.annotation.EnableSchedulerLock;

@Configuration
@EnableScheduling
@EnableSchedulerLock(defaultLockAtMostFor = "PT23H")
public class SchedulingConfiguration {

	@Value("${spring.data.mongodb.database}")
	private String database;

	@Bean
	LockProvider lockProvider(MongoClient mongoClient) {
		return new MongoLockProvider(mongoClient.getDatabase(database));
	}

}
