package de.ozgcloud.admin.common;

import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import org.springframework.core.annotation.AliasFor;

import com.fasterxml.jackson.annotation.JacksonAnnotationsInside;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.FIELD)
@Inherited

@JacksonAnnotationsInside
@JsonSerialize(using = LinkedResourceSerializer.class)
@JsonDeserialize(using = LinkedResourceDeserializer.class)
public @interface LinkedResource {

	Class<?> controllerClass();

	Class<? extends IdExtractor<Object>> extractor() default ToStringExtractor.class;

	@AliasFor(annotation = JsonDeserialize.class, attribute = "builder")
	Class<? extends ObjectBuilder<Object>> builder() default IdBuilder.class;
}