package de.ozgcloud.admin.keycloak;

import java.util.stream.Stream;

import org.springframework.stereotype.Service;

import lombok.RequiredArgsConstructor;

@Service
@RequiredArgsConstructor
public class KeycloakRemoteService {

	private final KeycloakApiService apiService;
	private final GroupMapper groupMapper;

	public Stream<Group> getGroupsWithOrganisationsEinheitId() {
		return groupMapper.fromGroupRepresentations(apiService.getAllGroups()).stream();
	}

	public String addGroup(AddGroupData addGroupData) {
		return apiService.addGroup(groupMapper.toGroupRepresentation(addGroupData));
	}
}
