package de.ozgcloud.admin.organisationseinheit;

import java.util.List;

import org.springframework.data.annotation.Id;
import org.springframework.data.annotation.TypeAlias;
import org.springframework.data.mongodb.core.mapping.Document;

import com.fasterxml.jackson.annotation.JsonIgnore;

import lombok.Builder;
import lombok.Getter;
import lombok.Singular;
import lombok.extern.jackson.Jacksonized;

@Getter
@Builder(toBuilder = true)
@Jacksonized
@Document(language = "german", collection = OrganisationsEinheit.COLLECTION_NAME)
@TypeAlias("OrganisationsEinheit")
public class OrganisationsEinheit {

	static final String COLLECTION_NAME = "organisationsEinheit";
	static final String FIELD_SETTINGS = "settings";

	@JsonIgnore
	@Id
	private String id;
	@JsonIgnore
	private String keycloakId;
	@JsonIgnore
	private String zufiId;
	@JsonIgnore
	private Long lastSyncTimestamp;
	@JsonIgnore
	private String parentId;
	@JsonIgnore
	@Singular
	private List<OrganisationsEinheit> children;

	private String name;
	private String organisationsEinheitId;
	private SyncResult syncResult;
	@Builder.Default
	private OrganisationsEinheitSettings settings = new OrganisationsEinheitSettings(null);
}