package de.ozgcloud.admin.setting;

import java.util.HashMap;
import java.util.Map;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonUnwrapped;

import de.ozgcloud.admin.organisationseinheit.OrganisationsEinheitSettings;
import de.ozgcloud.admin.setting.postfach.AbsenderVorgangManager;
import lombok.Builder;
import lombok.Getter;

@Builder
@Getter
class VorgangManagerSettingDTO implements ApplicationSettingDTO {
	@JsonUnwrapped(prefix = "ozgcloud.postfach.absender.")
	@Builder.Default
	private AbsenderVorgangManager absender = AbsenderVorgangManager.builder().build();

	@JsonProperty("ozgcloud.postfach.signatur")
	@Builder.Default
	private String signatur = "";

	@JsonProperty("ozgcloud.postfach.organisationsEinheitSettings")
	@Builder.Default
	private Map<String, OrganisationsEinheitSettings> organisationsEinheitSettings = new HashMap<>();
}
