package de.ozgcloud.admin.organisationseinheit;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.mockito.InjectMocks;
import org.springframework.hateoas.EntityModel;
import org.springframework.hateoas.Link;

import de.ozgcloud.admin.RootTestFactory;

class OrganisationsEinheitRootProcessorTest {

	@InjectMocks
	private OrganisationsEinheitRootProcessor organisationsEinheitRootProcessor;

	@Nested
	class TestProcess {

		@Nested
		class OrganisationsEinheitenLinkRelation {

			@Test
			void shouldExists() {
				var model = organisationsEinheitRootProcessor.process(EntityModel.of(RootTestFactory.create()));

				assertThat(model.getLink(OrganisationsEinheitRootProcessor.REL_ORGANISATIONS_EINHEITEN)).isNotEmpty();
			}

			@Test
			void shouldHaveHref() {
				var model = organisationsEinheitRootProcessor.process(EntityModel.of(RootTestFactory.create()));

				assertThat(model.getLink(OrganisationsEinheitRootProcessor.REL_ORGANISATIONS_EINHEITEN))
						.get()
						.extracting(Link::getHref)
						.isEqualTo(OrganisationsEinheitController.PATH);
			}
		}

	}

}