package de.ozgcloud.admin.setting;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.mongodb.core.MongoOperations;

import de.ozgcloud.common.test.DataITCase;

@DataITCase
class SettingRepositoryITCase {
	@Autowired
	private MongoOperations mongoOperations;
	@Autowired
	private SettingRepository repository;

	private final static String SETTING_NAME = "Name";
	private Setting setting = SettingTestFactory.createBuilder()
			.name(SETTING_NAME)
			.build();

	@Nested
	class TestFindOneByName {
		@Test
		void shouldGetSavedData() {
			mongoOperations.dropCollection(Setting.COLLECTION_NAME);
			mongoOperations.save(setting);

			var settingFromDb = repository.findOneByName(SETTING_NAME).get();

			assertThat(settingFromDb).usingRecursiveComparison().isEqualTo(setting);
		}
	}
}
